/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.obligation;

/**
 * Denotes that an argument value was detected to be an instance of
 * the incorrect Java Class.
 * @author Erin.Reddick AT gtri.gatech.edu
 *
 */
@SuppressWarnings("serial")
public class InvalidObligationArgumentException extends ObligationHandlerException {

	/**
	 * Basic Exception constructor
	 * @param argumentId ID of the invalid argument
	 * @param clazz expected Java Class of the argument
	 */
	public InvalidObligationArgumentException(String argumentId, Class<?> clazz) {
		super("Argument: " + argumentId + " excepted to be an instanceof " + clazz.getName());
	}
}
