/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.obligation;

/**
 * Denotes exception cases that can be raised during the handling of obligations
 * @author Erin.Reddick AT gtri.gatech.edu
 *
 */
@SuppressWarnings("serial")
public class ObligationHandlerException extends Exception {

	/**
	 * Passes the arguments up to the super class
	 * @param message
	 * @param cause
	 */
	public ObligationHandlerException(String message, Throwable cause) {
		super(message, cause);
	}
	
	/**
	 * Passes the argument up to the super class
	 * @param cause
	 */
	public ObligationHandlerException(Throwable cause) {
		super(cause);
	}
	
	/**
	 * Passes the argument up to the super class
	 * @param message
	 */
	public ObligationHandlerException(String message) {
		super(message);
	}
}
