/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.portal;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@SuppressWarnings("serial")
public class FileUtility extends HttpServlet {
	
	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		String operation = request.getParameter("op");
		String fileName = request.getParameter("fileName");
		
		if(operation == null || operation.isEmpty() || operation.equals("download"))
			viewFile(request, response, fileName);
		else if(operation.equals("view"))
			viewFile(request, response, fileName);
	}

	private void viewFile(HttpServletRequest request,
			HttpServletResponse response, String fileName) throws ServletException, IOException {
        response.setContentType("text/xml");
        //response.setHeader("Content-Disposition", "attachment;filename=" + fileName);
        writeFile(response, fileName);
	}

	/*
	private void downloadFile(HttpServletRequest request, HttpServletResponse response, String fileName) throws ServletException, IOException {
        response.setContentType("application/x-download");
        response.setHeader("Content-Disposition", "attachment;filename=" + fileName);
        writeFile(response, fileName);
	}
	*/

	/**
	 * @param response
	 * @param fileName
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	private void writeFile(HttpServletResponse response, String fileName)
			throws ServletException, IOException {
		File tempDirectory = (File)getServletContext().getAttribute("javax.servlet.context.tempdir");
		
		File file = new File(tempDirectory, fileName);
		byte[] buffer = new byte[(int)file.length()];
		FileInputStream fis = new FileInputStream(file);
		fis.read(buffer);

        ServletOutputStream sos = response.getOutputStream();
        sos.write(buffer);
        sos.flush();
        sos.close();
	}


}
