<!-- Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. -->
<%@page import="java.io.InputStream"%>
<%@page import="com.sun.xml.wss.saml.internal.saml20.jaxb20.AttributeStatementType"%>
<%@page import="com.sun.xml.wss.saml.internal.saml20.jaxb20.StatementAbstractType"%>
<%@page import="java.util.List"%>
<%@page import="javax.xml.bind.Marshaller"%>
<%@page import="javax.xml.bind.JAXBContext"%>
<%@page import="java.io.FileOutputStream"%>
<%@page import="com.sun.xml.wss.saml.internal.saml20.jaxb20.AssertionType"%>
<%@page import="javax.xml.bind.JAXBElement"%>
<%@page import="org.gtri.icl.iead.policy_guide.portal.SAMLAssertionParser"%>
<%@page import="org.gtri.icl.iead.policy_guide.wsc.SampleWSCClient"%>
<%@page import="java.io.File"%>

<%
	String localId = null;
	InputStream assertionIs = (InputStream)request.getSession().getAttribute("assertionIs");
	JAXBElement<AssertionType> jaxbAssertion = SAMLAssertionParser.parseAssertion(assertionIs);

	//write the assertion to a temp file so it can be downloaded
	File tempDirectory = (File) getServletContext().getAttribute("javax.servlet.context.tempdir");
	File assertionFile = File.createTempFile("samlAssertion", ".xml", tempDirectory);
	
	String assertionFileName = assertionFile.getName();
	FileOutputStream assertionOs = new FileOutputStream(assertionFile);
	JAXBContext jc = JAXBContext.newInstance(AssertionType.class);
	Marshaller m = jc.createMarshaller();
	m.marshal(jaxbAssertion, assertionOs);
	assertionOs.close();
	
	AssertionType assertion = jaxbAssertion.getValue();
	List<StatementAbstractType> stmtAbstTypes = assertion.getStatementOrAuthnStatementOrAuthzDecisionStatement();
	for (StatementAbstractType stmtAbstType : stmtAbstTypes) {
		if (!(stmtAbstType instanceof AttributeStatementType))
			continue;

		AttributeStatementType attrStmtType = (AttributeStatementType) stmtAbstType;
		List<Object> attrObjs = attrStmtType.getAttributeOrEncryptedAttribute();

		for (Object attrObj : attrObjs) {
			if (!(attrObj instanceof com.sun.xml.wss.saml.internal.saml20.jaxb20.AttributeType))
				continue;

			com.sun.xml.wss.saml.internal.saml20.jaxb20.AttributeType samlAttr = (com.sun.xml.wss.saml.internal.saml20.jaxb20.AttributeType) attrObj;
			//System.out.println(attrType.getName());
			String xacmlAttrId = samlAttr.getName();
			if (!(xacmlAttrId.equals("gfipm:2.0:user:LocalId")))
				continue;
			localId = (String) samlAttr.getAttributeValue().get(0);
			break;
		}
	}

	String thisUri = request.getRequestURI();
	String recordId = request.getParameter("record_id");

%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>GPPTF Implementation Guide Sample Application</title>
</head>
<body>
	<h2>
		Global Privacy Policy Technical Framework Implementation Guide Sample
		Application<br />
	</h2>
	<h2>Web Portal for Reading Arrest Records</h2>
	<a href="<%=thisUri%>">Home</a><br /><br />
	Logged in as:
	<%=localId%><br />
	<a target="_blank" href="file?fileName=<%=assertionFileName%>">GFIPM
		User SAML Assertion</a>
	<br />
	<br />
	<%
		if (recordId == null || recordId.isEmpty()) {
	%>
	<%@ include file="read_form.jsp"%>
	<%
		} else {
	%>
	Reading
	<%=recordId%><br />
	<%
			tempDirectory = (File) getServletContext().getAttribute("javax.servlet.context.tempdir");
			File requestFile = File.createTempFile("xacmlRequest", ".xml", tempDirectory);
			File responseFile = File.createTempFile("xacmlResponse", ".xml", tempDirectory);
			File dataFile = File.createTempFile("data", ".xml", tempDirectory);
			assertionFile = new File(tempDirectory, assertionFileName);

			SampleWSCClient.executeRead(recordId, assertionFile, requestFile, responseFile, dataFile);
	%>
			<a target="_blank" href="file?fileName=<%=requestFile.getName()%>">XACML Request</a>
			<a target="_blank" href="file?fileName=<%=responseFile.getName()%>">XACML Response</a>
	<%
			if(dataFile.length() == 0) {
	%>
			No Arrest Data Returned<br /><br />
	<%
			} else {
	%>
			<a target="_blank" href="file?fileName=<%=dataFile.getName()%>">Arrest Record</a>
	<%
			}
	%>
	<%
		}
	%>
</body>
</html>
