/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.service;

/**
 * Enumeration for the GFIPM Action Type Codeset
 * @author Erin.Reddick AT gtri.gatech.edu
 *
 */
public enum GFIPMActionTypeCode {

	CREATE ("Create"),
	READ ("Read"),
	UPDATE ("Update"),
	DELETE ("Delete"),
	SEARCH ("Search");
	
	/**
	 * The code value
	 */
	private final String code;
	
	/**
	 * Basic constructor that sets the code value
	 * @param code the code value
	 */
	private GFIPMActionTypeCode(String code) {
		this.code = code;
	}
	
	/**
	 * @return the code value
	 */
	public String getCode() {
		return this.code;
	}
}
