/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.service;

/**
 * This class is an enumeration of all XACML attributes from the
 * GFIPM Metadata Spec that are used in the Sample Application.
 * @author Erin.Reddick AT gtri.gatech.edu
 *
 */
public enum GFIPMAttribute {

	ACTION_TYPE (new XACMLAttribute("gfipm:2.0:action:ActionType", "http://www.w3.org/2001/XMLSchema#string")),
	CRIMINAL_HISTORY_DATA_INDICATOR (new XACMLAttribute("gfipm:2.0:resource:CriminalHistoryDataIndicator", "http://www.w3.org/2001/XMLSchema#boolean"));
	
	/**
	 * Each enumerated value is backed by an instance of XACMLAttribute
	 */
	private final XACMLAttribute attribute;

	/**
	 * Basic constructor that sets the XACMLAttribute
	 * @param attribute the XACMLAttribute for this GFIPM attribute
	 */
	private GFIPMAttribute(XACMLAttribute attribute) {
		this.attribute = attribute;
	}

	/**
	 * @return the XACMLAttribute
	 */
	public XACMLAttribute getAttribute() {
		return attribute;
	}

}
