/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
/*
 * Used in holder of the key profile.
 */

package org.gtri.icl.iead.policy_guide.service;

import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.security.auth.Subject;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.sun.xml.wss.XWSSecurityException;
import com.sun.xml.wss.impl.callback.SAMLValidator;
import com.sun.xml.wss.saml.util.SAMLUtil;

public class GFIPMSAMLAssertionValidator implements SAMLValidator {

    @SuppressWarnings({ "deprecation", "rawtypes" })
	public void validate(Element elmnt, Map map, Subject sbjct) throws SAMLValidationException {
        throw new UnsupportedOperationException("Not supported yet.1");
    }

    @SuppressWarnings({ "rawtypes", "deprecation" })
	public void validate(XMLStreamReader xmlStreamerReader, Map map, Subject sbjct) throws SAMLValidationException {
        
        System.out.println("<<<<<<<<<<<<<<<<<<WSP: Validating SAML Assertion>>>>>>>>>>>>>>>");
        
        try {
            
            Element domSamlAssertion = SAMLUtil.createSAMLAssertion(xmlStreamerReader);

            //dump the assertion to STDOUT
            try {
                dumpDomNode(domSamlAssertion);
            } catch ( TransformerException ex) {
                System.out.println("Error Dumping SAML Assertion");
            }            

            //Do a SAML:Conditions validation to make sure the SAML assertion is Valid
            SAMLUtil.validateTimeInConditionsStatement(domSamlAssertion);
//TODO            SAMLUtil.verifySignature(domSamlAssertion, null)
            System.out.println("<<<<<<<<<<<<<<<<<<<WSP:SAML Validation Successful>>>>>>>>>>>>>>>");

            //get hold of the SAML:NameIdentifier element
            NodeList nidList = domSamlAssertion.getElementsByTagNameNS("urn:oasis:names:tc:SAML:2.0:assertion","NameIdentifier");
            Node nid = null;
            System.out.println("WSP:Here");
            if (nidList.getLength() > 0) {
                nid = nidList.item(0);
            }
            System.out.println("WSP:And here" + nid);
//            String child = nid.getFirstChild().getNodeValue();
            //set the Subject Principal's upon successful validaton.
            // Set the Principal into the Subject if the NameIdentifier is a Valid Doctor
            //TODO: Provider Metro API to create and add a Principal to subject.
//            System.out.println("\n\n\n\n Subject Principal's NameId: " + child);

            //!!! Extermely important - if we want to be able to access the saml assertion in the client through 
            //SubjectAccessor.getRequesterSubject(context); we have to add it here
            sbjct.getPublicCredentials().add(domSamlAssertion);

        } catch (XWSSecurityException ex) {
            Logger.getLogger(GFIPMSAMLAssertionValidator.class.getName()).log(Level.SEVERE, null, ex);
            throw new SAMLValidationException(ex);
        } catch (XMLStreamException ex) {
            Logger.getLogger(GFIPMSAMLAssertionValidator.class.getName()).log(Level.SEVERE, null, ex);
            throw new SAMLValidationException(ex);
        }

    }

    @SuppressWarnings("deprecation")
	public void validate(Element elmnt) throws SAMLValidationException {
        throw new UnsupportedOperationException("Not supported yet.3");
    }

    @SuppressWarnings("deprecation")
	public void validate(XMLStreamReader reader) throws SAMLValidationException {
        throw new UnsupportedOperationException("Not supported yet.4");
    }

    private static void dumpDomNode(Node node) throws TransformerException {
        System.out.println("==== DebugUtil.dumpDomNode(...) Start ====");
        DOMSource domSource = new DOMSource(node);
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer xform = null;
        xform = tf.newTransformer();
        xform.transform(domSource, new StreamResult(System.out));
        System.out.println();
        System.out.println("==== DebugUtil.dumpDomNode(...) End ====");
    }
}
