/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.service;

/**
 * This class models an attribute of an attribute dictionary.
 * A dictionary should at least specify the identifier and
 * XACML datatype of each attribute.
 * @author Erin.Reddick AT gtri.gatech.edu
 *
 */
public class XACMLAttribute {
	
	/**
	 * The identifier of the attribute
	 */
	private final String uri;
	
	/**
	 * The datatype of the attribute
	 */
	private final String datatype;
	
	/**
	 * Basic constructor that sets the uri and datatype
	 * @param uri The identifier of the attribute
	 * @param datatype The datatype of the attribute
	 */
	public XACMLAttribute(String uri, String datatype) {
		this.uri = uri;
		this.datatype = datatype;
	}

	/**
	 * @return the uri
	 */
	public String getUri() {
		return uri;
	}

	/**
	 * @return the datatype
	 */
	public String getDatatype() {
		return datatype;
	}
	
}
