/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.service;

/**
 * This class is an enumeration of all XACML attributes from the
 * XACML 2.0 specification that are used in the Sample Application.
 * @author Erin.Reddick AT gtri.gatech.edu
 *
 */
public enum XACMLStandardAttribute {

	RESOURCE_ID (new XACMLAttribute("urn:oasis:names:tc:xacml:1.0:resource:resource-id", "http://www.w3.org/2001/XMLSchema#string")),
	CURRENT_TIME (new XACMLAttribute("urn:oasis:names:tc:xacml:1.0:environment:current-time", "http://www.w3.org/2001/XMLSchema#time")),
	CURRENT_DATE (new XACMLAttribute("urn:oasis:names:tc:xacml:1.0:environment:current-date", "http://www.w3.org/2001/XMLSchema#date")),
	CURRENT_DATETIME (new XACMLAttribute("urn:oasis:names:tc:xacml:1.0:environment:current-dateTime", "http://www.w3.org/2001/XMLSchema#dateTime"));

	/**
	 * Each enumerated value is backed by an instance of XACMLAttribute
	 */
	private final XACMLAttribute attribute;
	
	/**
	 * Basic constructor that sets the XACMLAttribute
	 * @param attribute the XACMLAttribute for this XACML standard attribute
	 */
	private XACMLStandardAttribute(XACMLAttribute attribute) {
		this.attribute = attribute;
	}

	/**
	 * @return the XACMLAttribute
	 */
	public XACMLAttribute getAttribute() {
		return attribute;
	}

}
