/* Copyright 2011-2012, Georgia Institute of Technology. All rights reserved. */
package org.gtri.icl.iead.policy_guide.test;

import java.security.Principal;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.security.auth.Subject;
import javax.xml.bind.JAXBElement;
import javax.xml.ws.handler.MessageContext;

import com.sun.xml.wss.impl.MessageConstants;
import com.sun.xml.wss.saml.internal.saml20.jaxb20.AssertionType;

public class TestMessageContext implements MessageContext {

	private final Subject subject;
	private final Map<String, Object> objects;
	private final TestServletContext testSc;
	
	public TestMessageContext(JAXBElement<AssertionType> userSamlAssertion, String basePath) {
		this.objects = new HashMap<String, Object>();

		Set<Object> subjPubCreds = new HashSet<Object>();
		subjPubCreds.add(userSamlAssertion);
		this.subject = new Subject(true, new HashSet<Principal>(), subjPubCreds, new HashSet<Object>());
		this.objects.put(MessageConstants.AUTH_SUBJECT, this.subject);

		this.testSc = new TestServletContext(basePath);
		this.objects.put(MessageContext.SERVLET_CONTEXT, testSc);
	}
	
	@Override
	public void clear() {
		objects.clear();
	}

	@Override
	public boolean containsKey(Object key) {
		return objects.containsKey(key);
	}

	@Override
	public boolean containsValue(Object value) {
		return objects.containsValue(value);
	}

	@Override
	public Set<java.util.Map.Entry<String, Object>> entrySet() {
		return objects.entrySet();
	}

	@Override
	public Object get(Object key) {
		return objects.get(key);
	}

	@Override
	public boolean isEmpty() {
		return objects.isEmpty();
	}

	@Override
	public Set<String> keySet() {
		return null;
	}

	@Override
	public Object put(String arg0, Object arg1) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void putAll(Map<? extends String, ? extends Object> arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public Object remove(Object arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int size() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public Collection<Object> values() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Scope getScope(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setScope(String arg0, Scope arg1) {
		// TODO Auto-generated method stub

	}

}
